/****************************************************************************
 * This is an automated questmaster snippet. Its based off the concept of   *
 * the questmaster snippet found all over the place. As such the credits are*
 * a completely disgusting tangle.                                          *
 * The nearest semblence of ownership I can determine is this comes from ROM*
 * was created by Vassago for the mud Moongate, then Vir ported it from ROM *
 * to SMAUG, then LrdElder allegedly edited it and released it for smaug 1.4*
 *                                                                          *
 * Regardless of how it got there, the one floating about is pretty crappy  *
 * And has tons of bugs in it, and since I'm sick of hearing questions about*
 * ways to fix it, therefore I've rewritten it in my own way to make it more*
 * compatible, and quite frankly workable.                                  *
 *                                                                          *
 * I myself add no terms or conditions to this code, simply because I don't *
 * care. If you're going to steal it, you will whether I tell you you can or*
 * not, likewise if you wish to do something special like mention me or the *
 * other authors or whatever, somewhere, this is also entirely up to you,   *
 * and not something I can force you to do, etc.                            *
 *                                                                          *
 * Whether or not you follow the license of the previous ways this snippet  *
 * has been affected is also up to you. Because this is entirely rewritten, *
 * I have no idea whether or not you're bound by the licenses of the first  *
 * version that exists since you're not actually using it, but as far as I  *
 * am aware, you are not constrained in any way by those licenses since this*
 * work is not a derivitive of that, nor a copy of it, merely something that*
 * was inspired by it (Aka I looked at it and said "It'd work much better if*
 * if it were like this", and so wrote my own this way learning from the    *
 * quite hideous mistakes in the other).                                    *
 *                                                                          *
 * The installation instructions are within the readme.txt, this also will  *
 * detail what the functions are, and do, as well as some other practical   *
 * usages for them. The license.txt includes the headers/licenses from the  *
 * inspirational work for those who are interested or concerned.            *
 *                                                                          *
 *                                         -Aurora                          *
 *                                          EternalEmpress@Lostprophecy.com *
 ****************************************************************************/


Welcome to the instruction manual. Be afraid.
This truly is not anything difficult to install, so sit back, relax and we'll take
a whirlwind tour of "howto".

Some notes on this 'snippet':
 If you do not use extended bitvectors on rooms, you will need to adjust from using
  "xIS_SET" to just "IS_SET" within these instructions and the source. You will also
  have to do this to any other pieces that do not use extended bitvectors that should.
  If you do not have extended bitvectors you may need to update to them in order to be
  capable of using this.

We'll begin in mud.h, since it truly is where all the fun begins.

You'll need to declare the following new things to make this work.


after:
typedef struct  auction_data            AUCTION_DATA;	/* auction data */
add:
typedef struct  quest_data              QUEST_DATA;	/* questmaster data */

Find a place to add in the following: 

#define MAX_QDATA 10  /* You can set this to however many available slots you want. */

struct  quest_data
{
    int 	level_range;
    int	 	practice_amt;
    int		practice_cost;
    int		award_vnum[MAX_QDATA+1];
    int		award_value[MAX_QDATA+1];
    int		gold_amt;
    int		gold_cost;
};

With the other externals in mud.h, after:
extern          AUCTION_DATA      *     auction;
add:
extern          QUEST_DATA      *     questmaster;

After
#define ACT_PROTOTYPE		 30		/* A prototype mob	*/

You will need to add to the end of the list:

#define ACT_QUESTMASTER		 <whatever is the next number on yours> /* Questmaster */

To player_flags you will need to add:

PLR_QUESTOR

Both of these defines will need to have thier flag added to the appropriate lists inside
build.c as well.

then to the pc_data structure add:

    char *              questarea; /* Questmaster */
    char *              questroom; /* Questmaster */
    CHAR_DATA *         questgiver; /* Questmaster */
    sh_int              nextquest; /* Questmaster */
    sh_int              countdown; /* Questmaster */
    sh_int              questobj; /* Questmaster */
    sh_int              questmob; /* Questmaster */

(We do this because mobs cannot quest, and mobs do not have pcdata, so it keeps things
slightly more tidy for us)

inside db.c
add to the global declarations.
void    fread_questmaster     args( ( void ) );

under: 
AUCTION_DATA    * 	auction;	/* auctions */
add:
QUEST_DATA    * 	questmaster;	/* questmaster */


After load_weather_data is called add:

    CREATE( questmaster, QUEST_DATA, 1 );
    fread_questmaster();
	log_string("Awakening Questmaster");

with the files in mud.h after:
#define AREA_LIST	"area.lst"	/* List of areas		*/
add:
#define QUEST_FILE   SYSTEM_DIR "quest.dat" /* Storing qmaster stuff */


While we are in this file is a good chance to add a global declaration for:

CD *	get_mob		args( ( int vnum) );
OD *	obj_by_vnum	args( ( int vnum) );

And add in the following two functions in a file somewhere (I have them in handler.c).

/*
 * Find a mob in the world by vnum.
 */
CHAR_DATA *get_mob(int vnum)
{
    CHAR_DATA *wch;

    /* check the world for an exact match */
    for ( wch = first_char; wch; wch = wch->next )
	if (IS_NPC(wch) && vnum == wch->pIndexData->vnum )
		return wch;

    return NULL;
}

/*
 * Find an obj in the world based on its vnum
 */
OBJ_DATA *obj_by_vnum(int vnum)
{
    OBJ_DATA *obj;

    for ( obj = first_object; obj; obj = obj->next )
	if ( vnum == obj->pIndexData->vnum)
		return obj;

    return NULL;
}

These are highly useful functions when you're in need of locating a mobile or object
within the world just by its vnum without a specific being forcing the search, etc.
get_char_world can only identify by name unless an immortal does it, and is limited
to things that the character who initiates it can see, etc. Neither is complicated,
but both have infinite applications for usage, and the questmaster code makes good
usage of them both in finding randomly determined beings/objs. (I bring attention
to these features just because you may wish to use them elsewhere in your code to
work on other things, as they're not limited to use solely for this purpose).

Anyhow, enough on that, and more on actually installing the questmaster itself.

in free_char we will have to deal with the new additions.

Within the pcdata section of it add:

        if (ch->pcdata->questarea)
          STRFREE(ch->pcdata->questarea);
        if (ch->pcdata->questroom)
          STRFREE(ch->pcdata->questroom);

to save.c we will save very little quest data, since quitting should clear a quest
(Due to time limits etc, having them come back 4 hours later to complete a quest,
or give them selves time to log off and do it as an alt, etc, did not seem prudent.)

in fwrite_char we add the timer though, so that a player cannot do a quest, quit, and
come back for another.

    if (ch->pcdata->nextquest != 0)
        fprintf( fp, "NextQuest %d\n",  ch->pcdata->nextquest   );

in fread_char in section N add

            KEY( "NextQuest",   ch->pcdata->nextquest,          fread_number( fp ) );

in update.c in the function update_handler find the section where area_update is used.
Below it add:

        quest_update     ( );
This will allow quest info to be updated once per tick, so that quest counters decrement
properly. At the top of update.c you shall have to declare this function as well.

void    quest_update    args( ( void ) ); /* Questmaster */

You will be able to see the local functions declared similarly to identify where to place
this.
Example:
void	char_check	args( ( void ) );

in fight.c add to group_gain at the very beginning:

    if (!IS_NPC(ch) && xIS_SET(ch->act, PLR_QUESTOR) && IS_NPC(victim))
        {
            if (ch->pcdata->questmob == victim->pIndexData->vnum)
            {
		send_to_char("You have completed your quest!\n\r",ch);
                send_to_char("Return to the questmaster to recieve your reward before your time runs out!\n\r",ch);
                ch->questmob = -1;
            }
        }

Next in act_info.c in the function show_char_to_char_0 add a check like:

    if (IS_NPC(victim) && !IS_NPC(ch) && ch->pcdata->questmob > 0 && victim->pIndexData->vnum == ch->pcdata->questmob)
        strcat( buf, "[TARGET] ");

(If you have color code you're encouraged to add it here to make the target look
more visible for your players)

in act_info.c again, in format_obj_to_char after the :

 buf[0] = '\0';
add:
    if ( !IS_NPC(ch) && ch->pcdata->questobj > 0 && obj->pIndexData->vnum == ch->pcdata->questobj)   
     strcat( buf, "[TARGET] "     );

This will ensure a player knows when they've found the right mobile/item.

Now to add greater versatility to higher level immortals, we edit mset in build.c

    if ( !str_cmp( arg2, "nextquest" ) )
    {
	if ( IS_NPC(victim) )
	{
	    send_to_char( "Not on NPC's.\n\r", ch );
	    return;
	}

	if ( value < 0 || value > 30 )
	{
	    send_to_char( "The current quest range is 0 to 30.\n\r", ch );
	    return;
	}

	victim->pcdata->nextquest = value;
	return;
    }

    if ( !str_cmp( arg2, "countdown" ) )
    {

	if ( IS_NPC(victim) )
	{
	    send_to_char( "Not on NPC's.\n\r", ch );
	    return;
	}

	if ( value < 1 || value > 30 )
	{
	    send_to_char( "The current quest range is 1 to 30.\n\r", ch );
	    return;
	}

	victim->pcdata->countdown = value;
	return;
    }

    if ( !str_cmp( arg2, "questobj" ) )
    {

	if ( IS_NPC(victim) )
	{
	    send_to_char( "Not on NPC's.\n\r", ch );
	    return;
	}

	if ( value < 0 || value > 2000000 )
	{
	    send_to_char( "The current object target range is 0 to 2000000.\n\r", ch );
	    return;
	}

	victim->pcdata->questobj = value;
	victim->pcdata->questmob = 0;
	return;
    }

    if ( !str_cmp( arg2, "questmob" ) )
    {
	if ( IS_NPC(victim) )
	{
	    send_to_char( "Not on NPC's.\n\r", ch );
	    return;
	}

	if ( value < 0 || value > 2000000 )
	{
	    send_to_char( "The current mob target range is 0 to 2000000.\n\r", ch );
	    return;
	}

	victim->pcdata->questmob = value;
	victim->pcdata->questobj = 0;
	return;
    }

These allow an immortal to change a players quest-target, time remaining, and time till
next quest. The following is information on the various functions of the questmaster code.

It should be noted msetting a player with the quest flag can turn a quest on/off. Turning
it on while they have no quest info set will not really help them any. Turning them off
will effectively irritate them. 
If you wish to give them a quest of your own choosing, you can use the setquest command 
to bestow one upon them. They will then be able to use the 'aquest complete; at any 
questmaster to collect a random reward when done. Can make a nice way to give a treat 
to a player.

An immortal can view the current information on a players questing status at any time
using the qstat command. A player can view his/her own information using "Aquest info".

Aquest supports the following arguments:

POINTS   - Displays the current glory of the player.
INFO     - Redisplays the goal and location.
TIME     - Displays current amount of time for quest, or time till next quest.
REQUEST  - Generates a quest.
REFUSE   - Refuses a quest.
COMPLETE - Collect reward for quest.
LIST     - Lists things available for purchase with glory. (You'll have to edit this area).
BUY      - Allows to buy the things listed.

qchance
This is a very weak random number generator with little value other than making a quick
easy way of determining if certain events should trigger. Any number over 65 will always
return TRUE.

quest_list
This simple function loops through the available quest rewards and sends them to the
character who initiates. Its called by aquest list.

quest_buy
Called by aquest buy, this loops through the awards searching for the number specified
and reacts appropriately.

fwrite_questmaster
Saves questmaster data.

fread_questmaster
loads questmaster data.

do_queststat
Main control panel for setting/changing questmaster.
No argument will display entire list.
queststat object <vnum> <value>
queststat gold <number> <value>
queststat practices <number> <value>
queststat range <range>

Range is how far above/below the level_differance the questmaster should search.

generate_quest will identify the sort of quest to assign, find the mob/obj for the quest,
and give the player the quest information.
It does this using the find_quest_mob and find_quest_obj functions.
If you ever wish to change your quest criteria, it is within these functions to do so.


If you wish to add some quest related tokens to prompt variables, the suggested means
of doing so would be as follows:

In comm.c find display_prompt and add the following:

      case 'Q':
        if (ch->nextquest > 1)
	 stat = ch->nextquest;
        else if (ch->countdown > 0)
	 stat = ch->countdown;
	break;

The only other things that will require being done, is to add the commands in.
if you do not know how to do this, it involves declaring them in tables.c and mud.h

The commands to add in are:

do_aquest
do_setquest
do_qstat
do_queststat 

Add quest.dat to your system directory and then reboot.

Aquest is the only mortal level command, though if you have a council devoted to
handling quest information the other two commands would be appropriate to them to
some degree, or at least qstat would. setquest may be a tad too easily abused unless
you trust your imms/players pretty well. Of course logging and punishing also works.

I cannot recall at this point anything else required to make this snippet work, aside
from now doing a make clean and recompile (Vitally necessary due to changes within
the pcdata structure).

If you have any problems and wish for my assistance you will need to send me a detailed
email regarding the problem(s). What you do with this information is entirely up to you.
Edit it. Post it. Massacre it. Claim credit for it. Whatever. Regardless of my will I'm 
sure someone somewhere will do all of the above anyway.

                                                       -Aurora
                                                        EternalEmpress@LostProphecy.com
